SystemOrganization addCategory: #ConfigurationOfMoose!

Object subclass: #ConfigurationOfMoose
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConfigurationOfMoose'!

!ConfigurationOfMoose class methodsFor: 'private' stamp: 'tg 11/17/2009 08:19'!
ensureMetacello
	Smalltalk at: #MetacelloProject ifAbsent: [
		Gofer new
				url: 'http://seaside.gemstone.com/ss/metacello';
				addPackage: 'ConfigurationOfMetacello';
				load.
		(Smalltalk at: #ConfigurationOfMetacello) loadLatestVersion ]! !

!ConfigurationOfMoose class methodsFor: 'metacello tool support' stamp: 'tg 10/19/2009 22:11'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfMoose class methodsFor: 'loading' stamp: 'simon.denier 10/27/2009 19:04'!
loadDefault
	(self project version: 'default') load.
	(Smalltalk at: #MooseScripts) perform: #openMooseWorkspace! !

!ConfigurationOfMoose class methodsFor: 'accessing' stamp: 'tg 10/19/2009 22:11'!
project

	^self new project! !

!ConfigurationOfMoose class methodsFor: 'loading' stamp: 'StephaneDucasse 11/17/2009 22:26'!
updateDefault
	"self updateDefault"
	
	"first update configuration"
	self project updateProject.
	"then load default version"
	self loadDefault! !

!ConfigurationOfMoose methodsFor: 'baselines' stamp: 'simon.denier 11/20/2009 23:50'!
default: spec 
	<version: 'default'>
	
	spec for: #common do: [
		spec blessing: #default.
		spec repository: 'http://www.squeaksource.com/Moose'.
		"External requirements"
		spec 
			package: 'Nile-Base' with: [spec repository: 'http://www.squeaksource.com/Nile'];
			package: 'Phexample' with: [spec repository: 'http://www.squeaksource.com/phexample'];
			package: 'Fame' with: [
				spec repository: 'http://www.squeaksource.com/Fame'.
				spec requires: #('Phexample')];
			package: 'Hashtable' with: [spec repository: 'http://www.squeaksource.com/ht'];
			package: 'Merlin' with: [spec repository: 'http://www.squeaksource.com/Merlin'];
			package: 'CollectionExtensions' with: [spec repository: 'http://www.squeaksource.com/CollectionExtensions'].
		"Moose packages"
		spec
			package: 'Moose-Core' with: [spec requires: #('Fame')];
			package: 'Famix-Specifications';
			package: 'Famix-Core' with: [ spec requires: #('Moose-Core') ];
			package: 'Famix-Implementation';
			package: 'Famix-Smalltalk' with: [spec file: 'Famix-Smalltalk-'. spec requires: 'Famix-Core'];
			package: 'Famix-Java' with: [ spec requires: #('Famix-Core') ];
			package: 'Famix-Extensions' with: [ spec requires: #('Famix-Core') ];
			package: 'Famix-File' with: [ spec requires: #('Famix-Core') ];
			package: 'Moose-Hismo';
			package: 'Famix-SourceAnchor' with: [ spec requires: #('Famix-Core') ];
			package: 'Moose-GenericImporter';
			package: 'Moose-SmalltalkImporter';
			package: 'Moose-MonticelloImporter';
			package: 'Moose-Finder' with: [ spec requires: #('Glamour for Moose') ];
			package: 'Moose-Wizard' with: [spec requires: #('Merlin')];
			package: 'Moose-LAN';
			package: 'Moose-ReferenceModel';
			package: 'Moose-Test-PackageOne';
			package: 'Moose-Test-PackageTwo';
			package: 'Famix-LANTests';
			package: 'Moose-ModelTest';
			package: 'Famix-Test';
			package: 'Moose-MondrianScripts' with: [
				spec requires: #('Mondrian for Moose' 'Famix-Extensions') ];
			package: 'Moose-MondrianPaintings' with: [
				spec requires: #('Mondrian for Moose' 'MooseAlgos for Moose') ];
			package: 'Moose-SmalltalkImporterTests';
			package: 'MooseKGB-TestFamix3';
			package: 'Moose-KGB-P4FullInteracted';
			package: 'Moose-KGB-P6InteractedReferee';
			package: 'Moose-KGB-P5FullReferee';
			package: 'Moose-KGB-P1FullReferencer';
			package: 'Moose-KGB-P2InteractedReferencerReferee';
			package: 'Moose-KGB-P3InteractedReferencer';
			package: 'Moose-KGB-P7ReferencerReferee';
			package: 'Moose-KGB-P8FullReferencer';
			package: 'Moose-KGB-P9FullReferencer';
			package: 'Moose-KGB-P10InteractedReferee';
			package: 'Moose-KGB-P11FullReferee';
			package: 'Moose-KGB-P12FullReferencer';
			package: 'Moose-KGB-P13FullReferencer';
			package: 'Moose-KGB-P14FullReferee';
			package: 'Moose-KGB-PExtensions';
			package: 'Moose-PackageBlueprint';
			package: 'Moose-Tests-PackageBlueprint';
			package: 'Moose-PB-P1Hierarchy';
			package: 'Moose-PB-P1Referencer';
			package: 'Moose-PB-P2Hierarchy';
			package: 'Moose-PB-P2Referee';
			package: 'Moose-PB-P3MiddleMan';
			package: 'Moose-PB-P4SelfContained'.
		spec
			group: 'Core' with: #(
				'Moose-Core'
				'Famix-Core'
				'Famix-Implementation'
				'Famix-Smalltalk'
				'Famix-Java'
				'Famix-Extensions'
				'Famix-File'
				'Moose-Hismo'
				'Famix-SourceAnchor'
				'Moose-GenericImporter'
				'Moose-SmalltalkImporter'
				'Moose-MonticelloImporter'
				'Mondrian for Moose'
				'MooseAlgos for Moose'
				'Glamour for Moose'
				'DSM for Moose'
				'SmallDude for Moose');
			group: 'UI' with: #( 'Moose-Finder' ); 
			group: 'Tests' with: #(
				"Libraries testing"
				'Fame'
				'Hashtable'
				'CollectionExtensions'
				"Moose testing"
				'Moose-LAN'
				'Moose-ReferenceModel'
				'Moose-Test-PackageOne'
				'Moose-Test-PackageTwo'
				'Famix-LANTests'
				'Moose-ModelTest'
				'Famix-Test'
				'Moose-SmalltalkImporterTests'
				'MooseKGB-TestFamix3'
				'Moose-KGB-P4FullInteracted'
				'Moose-KGB-P6InteractedReferee'
				'Moose-KGB-P5FullReferee'
				'Moose-KGB-P1FullReferencer'
				'Moose-KGB-P2InteractedReferencerReferee'
				'Moose-KGB-P3InteractedReferencer'
				'Moose-KGB-P7ReferencerReferee'
				'Moose-KGB-P8FullReferencer'
				'Moose-KGB-P9FullReferencer'
				'Moose-KGB-P10InteractedReferee'
				'Moose-KGB-P11FullReferee'
				'Moose-KGB-P12FullReferencer'
				'Moose-KGB-P13FullReferencer'
				'Moose-KGB-P14FullReferee'
				'Moose-KGB-PExtensions'
				'Moose-Tests-PackageBlueprint'
				'Moose-PB-P1Hierarchy'
				'Moose-PB-P1Referencer'
				'Moose-PB-P2Hierarchy'
				'Moose-PB-P2Referee'
				'Moose-PB-P3MiddleMan'
				'Moose-PB-P4SelfContained' ).
		spec
			project: 'MooseAlgos for Moose' with: [
				spec
					className: 'ConfigurationOfMooseAlgos';
					file: 'ConfigurationOfMooseAlgos';
					version: 'default';
					repository: 'http://www.squeaksource.com/MooseAlgos' ].
		spec project: 'DSM for Moose' with: [
				spec
					className: 'ConfigurationOfDSM';
					file: 'ConfigurationOfDSM';
					version: 'default';
					repository: 'http://www.squeaksource.com/dsm' ].
		spec project: 'Glamour for Moose' with: [
				spec
					className: 'ConfigurationOfGlamour';
					file: 'ConfigurationOfGlamour';
					version: 'default';
					repository: 'http://www.squeaksource.com/Glamour' ].
		spec project: 'Mondrian for Moose' with: [
				spec
					className: 'ConfigurationOfMondrian';
					file: 'ConfigurationOfMondrian';
					version: 'default';
					repository: 'http://www.squeaksource.com/Mondrian' ].
		spec project: 'SmallDude for Moose' with: [
				spec
					className: 'ConfigurationOfSmallDude';
					file: 'ConfigurationOfSmallDude';
					version: 'default';
					repository: 'http://www.squeaksource.com/SmallDude' ].
	]! !

!ConfigurationOfMoose methodsFor: 'accessing' stamp: 'tg 10/19/2009 22:11'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project]! !
